//-----------------------------------------------------------------------
// Globals
//-----------------------------------------------------------------------
var g_MessageType = "";
var g_MessageInfo = "";
//-----------------------------------------------------------------------
// SetMessage
//-----------------------------------------------------------------------
function SetMessage(type, info) {
  g_MessageType = type;
  g_MessageInfo = info;
  return;
}
//-----------------------------------------------------------------------
// ClearMessage
//-----------------------------------------------------------------------
function ClearMessage() {
  g_MessageType = "";
  g_MessageInfo = "";
  return;
}
//-----------------------------------------------------------------------
// GetMessageType
//-----------------------------------------------------------------------
function GetMessageType() {
  return g_MessageType;
}
//-----------------------------------------------------------------------
// GetMessageInfo
//-----------------------------------------------------------------------
function GetMessageInfo() {
  return g_MessageInfo;
}
//-----------------------------------------------------------------------
// GetMessageInfo
//-----------------------------------------------------------------------
function GetMessageInfo(newline) {
  var info = "";
  if (newline)
    info += "<br />";
  info += "<table><tr><td>";
  info += "<table class='message'>";
  info += "<tr><td>";
  info += "<img src='pic/" + g_MessageType.toLowerCase() + ".bmp' width='32px'>";
  info += "</td>";
  info += "<td width='15px'>";
  info += "</td>";
  info += "<td class='text' width='250px'>";
  info += g_MessageInfo;
  info += "</td></tr>";
  info += "</table>";
  info += "</td></tr></table>";
  return info;
}
//-----------------------------------------------------------------------
// GetPictureInformation
//-----------------------------------------------------------------------
function GetPictureInformation(name, size) {
  var info = "";
  info += "<table>";
  info += "<tr><td width='" + size + "' height='" + size + "' align='top'>";
  info += "<table class='image_" + name.toLowerCase() + "'>";
  info += "<tr><td valign='top' width='" + size + "' height='" + size + "'>";
  // Needed for Safari
  info += "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
  info += "</td></tr>";
  info += "</table>";
  info += "</tr></td>";
  info += "</table>";
  return info;
}
//-----------------------------------------------------------------------
// GetTitleInformation
//-----------------------------------------------------------------------
function GetTitleInformation(type) {
  var info = "";
  info += "<table class='head'>";
  info += "<tr>";
  info += "<td width='48px' height='48px'>";
  info += "<table class='image_" + type.toLowerCase() + "'>";
  info += "<tr><td width='48px' height='48px'>&nbsp;</td></tr>";
  info += "</table>";
  info += "</td>";
  info += "<td align='left' valign='middle'>" + GetString("TITLE_" + type) + "</td>";
  info += "</tr>";
  info += "</table>";
  return info;
}
//-----------------------------------------------------------------------
// GetPrintablePurpose
//-----------------------------------------------------------------------
function GetPrintablePurpose(ca, usage) {
  var value = "";
  if (ca) {
    value = GetString("TEXT_PURPOSE_ISSUER");
  }
  else if (usage == 0x40) {
    value = GetString("TEXT_PURPOSE_SIGNATURE");
  }
  else if ((usage & 0x40) != 0) {
    // Don't allow any other usage with non-rep 
    value = GetString("TEXT_PURPOSE_OTHER");
  }
  else if ((usage & 0x80) && (usage & 0x20)) {
    value = GetString("TEXT_PURPOSE_IDENTIFICATION");
  }
  else {
    value = GetString("TEXT_PURPOSE_OTHER");
  }
  return value;
}
//-----------------------------------------------------------------------
// GetPrintableKeyUsage
//-----------------------------------------------------------------------
function GetPrintableKeyUsage(usage) {
  var info = "";
  if (usage & 0x80)
    info += "Digital Signature, ";
  if (usage & 0x40)
    info += "Non Repudiation, ";
  if (usage & 0x20)
    info += "Key Encipherment, ";
  if (usage & 0x10)
    info += "Data Encipherment, ";
  if (usage & 0x08)
    info += "Key Agreement, ";
  if (usage & 0x04)
    info += "Key Cert Sign, ";
  if (usage & 0x02)
    info += "CRL Sign, ";
  if (info.length > 2)
    info = info.substr(0, info.length - 2);
  return info;
}
//-----------------------------------------------------------------------
// OnButton
//-----------------------------------------------------------------------
function OnButton(type) {
  var update_allowed = IsUpdateAllowed();
  ClearMessage();
  if (type == "ABORT")
    OnButtonAbort();
  else if ((type == "ADD_CERTIFICATE") && update_allowed)
    OnButtonAddCertificate();
  else if ((type == "ADD_TOKEN") && update_allowed)
    OnButtonAddToken();
  else if ((type == "ADD_VOLUME") && update_allowed)
    OnButtonAddVolume();
  else if ((type == "APPLY") && update_allowed)
    OnButtonApply();
  else if (type == "BACK")
    OnButtonBack();
  else if (type == "CHANGE_PASSWORD")
    OnButtonChangePassword();
  else if (type == "CONFIGURE")
    OnButtonConfigure();
  else if (type == "COPY")
    OnButtonCopy();
  else if ((type == "DELETE_CERTIFICATE") && update_allowed)
    OnButtonDeleteCertificate();
  else if ((type == "DELETE_TOKEN") && update_allowed)
    OnButtonDeleteToken();
  else if ((type == "DELETE_VOLUME") && update_allowed)
    OnButtonDeleteVolume();
  else if (type == "EXPORT_CERTIFICATE")
    OnButtonExportCertificate();
  else if (type == "EXPORT_TOKEN")
    OnButtonExportToken();
  else if (type == "INIT_TOKEN")
    OnButtonInitToken();
  else if ((type == "INSTALL") && update_allowed)
    OnButtonInstall();
  else if (type == "NEXT")
    OnButtonNext();
  else if (type == "RADIO")
    OnButtonRadio();
  else if (type == "READ")
    OnButtonRead();
  else if (type == "REFRESH")
    OnButtonRefresh();
  else if (type == "RESET_TOKEN")
    OnButtonResetToken();
  else if (type == "SAVE")
    OnButtonSave();
  else if (type == "SELECT")
    OnButtonSelect();
  else if (type == "TEST")
    OnButtonTest();
  else if (type == "TRACE_LOCAL")
    OnButtonTraceLocal();
  else if (type == "TRACE_GLOBAL")
    OnButtonTraceGlobal();
  else if (type == "TRACE_NONE")
    OnButtonTraceNone();
  else if (type == "VIEW_CERTIFICATE")
    OnButtonViewCertificate();
  else if ((type == "UNINSTALL") && update_allowed)
    OnButtonUninstall();
  else if (type == "UNLOCK_PASSWORD")
    OnButtonUnlockPassword();
  else if (type == "VIEW_TOKEN")
    OnButtonViewToken();
  return;
}
//-----------------------------------------------------------------------
// OnButtonRadio
//-----------------------------------------------------------------------
function OnButtonRadio() {
  var i = 0;
  if ((document.form1 != null) && (document.form1.radio1 != null)) {
    for (i = 0; i < document.form1.radio1.length; i++) {
      if (document.form1.radio1[i].checked) {
        OnButton(document.form1.radio1[i].value);
        break;
      }
    }
  }
  return;
}
//-----------------------------------------------------------------------
// SetButtonRadio
//-----------------------------------------------------------------------
function SetButtonRadio(value) {
  var i = 0;
  if ((document.form1 != null) && (document.form1.radio1 != null)) {
    for (i = 0; i < document.form1.radio1.length; i++) {
      if (document.form1.radio1[i].value == value)
        document.form1.radio1[i].checked = true;
      else
        document.form1.radio1[i].checked = false;
    }
  }
  return;
}
//-----------------------------------------------------------------------
// IsButtonRadioChecked
//-----------------------------------------------------------------------
function IsButtonRadioChecked(value) {
  var checked = false;
  var i = 0;
  if ((document.form1 != null) && (document.form1.radio1 != null)) {
    for (i = 0; i < document.form1.radio1.length; i++) {
      if (document.form1.radio1[i].value == value) {
        checked = document.form1.radio1[i].checked;
        break;
      }
    }
  }
  return checked;
}
//-----------------------------------------------------------------------
// SetButtonGroup
//-----------------------------------------------------------------------
function SetButtonGroup(value) {
  var i = 0;
  if ((document.form1 != null) && (document.form1.group1 != null)) {
    for (i = 0; i < document.form1.group1.length; i++) {
      if (document.form1.group1[i].value == value)
        document.form1.group1[i].checked = true;
      else
        document.form1.group1[i].checked = false;
    }
  }
  return;
}
//-----------------------------------------------------------------------
// GetButtonInfo
//-----------------------------------------------------------------------
function GetButtonInfo(type) {
  var info = "";
  var text = "";
  info += "<td align='left'>";
  text = GetButtonString(type);
  if ((text.indexOf("&lt;") == -1) && (text.indexOf("&gt;") == -1))
    text = "&nbsp;" + text + "&nbsp;";
  info += "<input type='button' id='" + type + "' ";
  info += "onclick='javascript:OnButton(\"" + type + "\");' value='" + text + "' />";
  info += "</td>";
  return info;
}
//-----------------------------------------------------------------------
// GetButtonRadioInfo
//-----------------------------------------------------------------------
function GetButtonRadioInfo(type, checked, direct) {
  var info = "";
  info += "<td class='radio'><input type='radio' name='radio1' value='";
  info += type;
  info += "'";
  if (checked)
    info += " checked";
  if (direct)
    info += " onclick='javascript:OnButton(\"" + type + "\");' ";
  info += " /></td>";
  info += "<td class='text'>";
  info += "<a href='javascript:OnButton(\"" + type + "\");'>";
  info += GetString("TEXT_" + type);
  info += "</a>";
  info += "</td>";
  return info;
}
//-----------------------------------------------------------------------
// ValidateButtons
//-----------------------------------------------------------------------
function ValidateButtons() {
  var i = 0;
  if (!IsUpdateAllowed()) {
    if (document.form1.radio1 != null) {
      for (i = 0; i < document.form1.radio1.length; i++) {
        if ((document.form1.radio1[i].value == "ADD_TOKEN") ||
            (document.form1.radio1[i].value == "DELETE_TOKEN") ||
            (document.form1.radio1[i].value == "ADD_CERTIFICATE") ||
            (document.form1.radio1[i].value == "DELETE_CERTIFICATE")) {
          document.form1.radio1[i].disabled = true;
          document.form1.radio1[i].checked = false;
        }
      }
    }
    if (document.form1.group1 != null) {
      for (i = 0; i < document.form1.group1.length; i++) {
        if (document.form1.group1[i].value == "-1") { // ADD_TOKEN
          document.form1.group1[i].disabled = true;
          document.form1.group1[i].checked = false;
        }
      }
    }
  }
  return;
}
//-----------------------------------------------------------------------
// GetInputFile
//-----------------------------------------------------------------------
function GetInputFile(name, text) {
  var info = "";
  if (IsExplorer()) {
    info += "<input name='qbrowse' type='file' style='display:none' />";
    info += "<input class='edit' name='" + name + "' type='text' />";
    info += "&nbsp;<input type='button' onclick='qbrowse.click();";
    info += name + ".value=qbrowse.value;'";
    info += " value='" + text + "' />";
  }
  else {
    info += "<input class='edit' name='" + name + "' type='file' size='50' />";
  }
  return info;
}
//-----------------------------------------------------------------------
// GetInputPassword
//-----------------------------------------------------------------------
function GetInputPassword(name, value) {
  var info = "";
  info += "<td align='left'>";
  info += "<input class='password' type='password' ";
  info += "name='" + name + "'";
  info += "value='" + value + "'";
  info += " />";
  info += "</td>";
  return info;
}
//-----------------------------------------------------------------------
// GetInputText
//-----------------------------------------------------------------------
function GetInputText(name) {
  var info = "";
  info += "<td align='left'>";
  info += "<input class='text' name='" + name + "' type='text' />";
  info += "</td><td></td>";
  return info;
}
//-----------------------------------------------------------------------
// GetExportArea
//-----------------------------------------------------------------------
function GetExportArea(name, data) {
  var info = "";
  info += "<td>";
  info += "<textarea class='data' name='" + name + "' cols='65' rows='10' readonly='true'>";
  info += data;
  info += "</textarea>";
  info += "</td>";
  return info;
}
//-----------------------------------------------------------------------
// GetImportArea
//-----------------------------------------------------------------------
function GetImportArea(name, data) {
  var info = "";
  info += "<td colspan='2'>";
  info += "<textarea class='data' name='" + name + "' cols='65' rows='10'>";
  info += data;
  info += "</textarea>";
  info += "</td>";
  return info;
}
