//-----------------------------------------------------------------------------
// Globals
//-----------------------------------------------------------------------------
var IS_INSTALLED = false;
//-----------------------------------------------------------------------------
// GetPartBy
//-----------------------------------------------------------------------------
function GetPartBy(text, pos, c) {
    var text2;
    var start;
    text2 = text;
    while ((text2 != "") && (pos > 0)) {
        if (text2.indexOf(c) > 0) {
            text2 = text2.substr(text2.indexOf(c) + 1, text2.length - text2.indexOf(c) - 1);
        }
        else if (text2.indexOf(c) == 0) {
            text2 = text2.substr(1, text2.length);
        }
        else {
            text2 = "";
        }
        pos--;
    }
    if (text2 != "") {
        if (text2.indexOf(c) > 0)
            text2 = text2.substr(0, text2.indexOf(c));
        else if (text2.indexOf(c) == 0)
            text2 = "";
    }
    return text2;
}
//-----------------------------------------------------------------------
// iid_Sleep
//-----------------------------------------------------------------------
function iid_Sleep() {
    setTimeout('', 100);
    return;
}
//-----------------------------------------------------------------------
// iid_IsInstalled
//-----------------------------------------------------------------------
function iid_IsInstalled() {
    return IS_INSTALLED;
}
//-----------------------------------------------------------------------
// iid_GetDeclare
//-----------------------------------------------------------------------
function iid_GetDeclare(explorer) {
    var value = "";
    if (explorer)
        value = "<object name='iid' id='iid' classid='CLSID:5BF56AD2-E297-416E-BC49-00B327C4426E' width=0 height=0></object>";
    else
        value = "<object name='iid' id='iid' type='application/x-iid' width=0 height=0></object>";
    return value;
}
//-----------------------------------------------------------------------
// iid_Declare
//-----------------------------------------------------------------------
function iid_Declare(name, explorer) {
    var success = false;
    var iid = null;
    iid = document.getElementById(name);
    if (iid != null) {
        iid.innerHTML = iid_GetDeclare(explorer);
        IS_INSTALLED = true;
        // Verify correct installation, version always available
        if (iid_GetProperty("Version") != "") {
            success = true;
        }
        else {
            IS_INSTALLED = false;
        }
    }
    return success;
}
//-----------------------------------------------------------------------
// iid_GetObject
//-----------------------------------------------------------------------
function iid_GetObject() {
    var iid = null;
    if (iid_IsInstalled())
        iid = document.getElementById("iid");
    return iid;
}
//-----------------------------------------------------------------------
// iid_NeedUpdate
//-----------------------------------------------------------------------
function iid_NeedUpdate(version) {
    var update = true;
    var iid = iid_GetObject();
    var value = "";
    if (iid != null) {
        value = iid.GetProperty("version");
        if (value >= version) {
            update = false;
        }
    }
    return update;
}
//-----------------------------------------------------------------------------
// iid_SetProperty
//-----------------------------------------------------------------------------
function iid_SetProperty(name, value) {
    var iid = iid_GetObject();
    if (iid != null) {
        try {
            iid.SetProperty(name, value);
        }
        catch (err) { }
    }
    return;
}
//-----------------------------------------------------------------------------
// iid_GetProperty
//-----------------------------------------------------------------------------
function iid_GetProperty(name) {
    var value = "";
    var iid = iid_GetObject();
    if (iid != null) {
        try {
            value = iid.GetProperty(name);
        }
        catch (err) { }
    }
    return value;
}
//-----------------------------------------------------------------------------
// iid_EnumProperty
//-----------------------------------------------------------------------------
function iid_EnumProperty(name, index) {
    var value = "";
    var iid = iid_GetObject();
    if (iid != null) {
        try {
            value = iid.EnumProperty(name, index);
        }
        catch (err) { }
    }
    return value;
}
//-----------------------------------------------------------------------------
// iid_Invoke
//-----------------------------------------------------------------------------
function iid_Invoke(name) {
    var value = "";
    var iid = iid_GetObject();
    if (iid != null) {
        try {
            value = iid.Invoke(name);
        }
        catch (err) { }
    }
    return value;
}
//-----------------------------------------------------------------------------
// iid_GetSlotName
//-----------------------------------------------------------------------------
function iid_GetSlotName(slotid) {
    var index = 0;
    var value = "";
    var name = "";
    while ((value = iid_EnumProperty('Slot', index)) != "") {
        if (GetPartBy(value, 0, ';') == slotid) {
            name = GetPartBy(value, 1, ';')
            break;
        }
        index++;
    }
    return name;
}
//-----------------------------------------------------------------------------
// iid_GetKeyUsage
//-----------------------------------------------------------------------------
function iid_GetKeyUsage(keyid) {
    var index = 0;
    var value = "";
    var usage = "";
    while ((value = iid_EnumProperty('Key', index)) != "") {
        if (GetPartBy(value, 2, ';') == keyid) {
            usage = GetPartBy(value, 5, ';')
            break;
        }
        index++;
    }
    return usage;
}
//-----------------------------------------------------------------------------
// iid_GetSignatureSlot
//-----------------------------------------------------------------------------
function iid_GetSignatureSlot(slotid, issuer, subject) {
    var index = 0;
    var value = "";
    var name = "";
    // Search for a token with same slot description which have a certificate 
    // with specified subject, issuer and non-rep key usage
    name = iid_GetSlotName(slotid);
    while ((value = iid_EnumProperty('Certificate', index)) != "") {
        if ((GetPartBy(value, 4, ';') == issuer) &&
        (GetPartBy(value, 5, ';') == subject)) {
            if (iid_GetSlotName(GetPartBy(value, 0, ';')) == name) {
                if (iid_GetKeyUsage(GetPartBy(value, 2, ';')) == "64") // non-rep
                {
                    slotid = GetPartBy(value, 1, ';');
                    break;
                }
            }
        }
        index++;
    }
    return slotid;
}
//-----------------------------------------------------------------------------
// iid_GetCertificateInfo
//-----------------------------------------------------------------------------
function iid_GetCertificateInfo(certificate) {
    var label = "";
    var name = "";
    var index = 0;
    var value = "";
    var i = 0;
    var slotid = "";
    var valid = "";
    // Enumerate all certificats until specified found. Take slotid for the
    // correct entry and get token label.
    while ((value = iid_EnumProperty('Certificate', index)) != "") {
        i = value.lastIndexOf(';')
        if (i != -1) {
            if (value.substr(i + 1) == certificate) {
                // Get certificate name from information returned, only short name
                name = GetPartBy(value, 3, ';');
                i = name.indexOf(',')
                if (i != -1)
                    name = name.substr(0, i);
                // Get token information from slotid returned
                slotid = GetPartBy(value, 0, ';');
                slotid = iid_GetSignatureSlot(slotid, GetPartBy(value, 4, ';'), GetPartBy(value, 5, ';'));
                iid_SetProperty('ActiveSlot', slotid);
                value = iid_GetProperty('TokenInfo');
                label = GetPartBy(value, 1, ';');
                // For Net iD 5.2 and later may validty be returned
                iid_SetProperty('Certificate', certificate);
                value = iid_GetProperty('CertificateInfo');
                valid = GetPartBy(value, 7, ';');
                if (valid.substr(0, 2) != '20')
                    valid = "";
                break;
            }
        }
        index++;
    }
    return label + ";" + name + ";" + valid;
}
//-----------------------------------------------------------------------------
// iid_CreateSignature
//-----------------------------------------------------------------------------
function iid_CreateSignature(certificate, pwd, data) {
    var rc = "";
    iid_SetProperty('Certificate', certificate);
    iid_SetProperty('Password', pwd);
    iid_SetProperty('DataToBeSigned', data);
    iid_SetProperty('Base64', 'true');
    iid_SetProperty('UrlEncode', 'false');
    rc = iid_Invoke('Sign');
    return rc;
}
//-----------------------------------------------------------------------------
// iid_GetSignature
//-----------------------------------------------------------------------------
function iid_GetSignature() {
    return iid_GetProperty('Signature');
}
