PKCS11_PUBLIC_READ_CERT = 0x1 << 28;
function pkcs11_InstallStatus(enablePrivilege) {
  var rc = -1; // Unknown status
  try {
    var nsIPKCS11ModuleDB = Components.interfaces.nsIPKCS11ModuleDB;
    if (nsIPKCS11ModuleDB != null) {
      if (enablePrivilege)
        netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
      var nsPKCS11ModuleDB = "@mozilla.org/security/pkcs11moduledb;1";
      var nsDB = Components.classes[nsPKCS11ModuleDB].getService(nsIPKCS11ModuleDB);
      if (nsDB != null) {
        rc = 0; // Not installed
        var module = nsDB.findModuleByName("Net iD");
        if (module != null)
          rc = 1; // Installed
      }
    }
  }
  catch (err) {
  }
  return rc;
}
function pkcs11_Install(path) {
  var rc = -1; // Unknown status
  try {
    var nsIPKCS11 = Components.interfaces.nsIPKCS11;
    if (nsIPKCS11 == null) {
      // Old install
      pkcs11.addmodule("Net iD", path, PKCS11_PUBLIC_READ_CERT, 0);
    } else {
      // New install Firefox 3.0+
      var nsPKCS11ContractID = "@mozilla.org/security/pkcs11;1";
      netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
      var PKCS11 = Components.classes[nsPKCS11ContractID].getService(nsIPKCS11);
      PKCS11.addModule("Net iD", path, PKCS11_PUBLIC_READ_CERT, 0);
    }
  }
  catch (err) {
    // Show exception if not expected status
    if (pkcs11_InstallStatus(false) != 1)
      alert(err); 
  }
  rc = pkcs11_InstallStatus(false);
  return rc;
}
function pkcs11_Uninstall() {
  var rc = -1; // Unknown status
  try {
    var nsIPKCS11 = Components.interfaces.nsIPKCS11;
    if (nsIPKCS11 == null) {
      pkcs11.deletemodule("Net iD");
    } else {
      var nsPKCS11ContractID = "@mozilla.org/security/pkcs11;1";
      netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
      var PKCS11 = Components.classes[nsPKCS11ContractID].getService(nsIPKCS11);
      PKCS11.deleteModule("Net iD");
    }
  }
  catch (err) {
    // Show exception if not expected status
    if (pkcs11_InstallStatus(false) != 0)
      alert(err);
  }
  rc = pkcs11_InstallStatus(false);
  return rc;
}
