IncludeJavascript("convert.js");
//-----------------------------------------------------------------------
// Globals
//-----------------------------------------------------------------------
var VARIABLES = "";
//-----------------------------------------------------------------------
// SetStoredVariable
//-----------------------------------------------------------------------
function SetStoredVariable(name, value) {
  var i = 0;
  var tmp = "";
  var variables = "";
  if ((name.indexOf(";") == -1) &&
      (name.indexOf("|") == -1) &&
      (value.indexOf(";") == -1) &&
      (value.indexOf("|") == -1)) {
    // Remove eventual old value
    while ((tmp = GetPartBy(VARIABLES, i, ";")) != "") {
      if (GetPartBy(tmp, 0, "|") != name)
        variables += tmp + ";";
      i++;
    }
    // Append new value
    VARIABLES = variables + name + "|" + value + ";";
  }
  return;
}
//-----------------------------------------------------------------------
// GetStoredVariable
//-----------------------------------------------------------------------
function GetStoredVariable(name) {
  var i = 0;
  var value = "";
  // Enumerate all values
  while ((value = GetPartBy(VARIABLES, i, ";")) != "") {
    if (GetPartBy(value, 0, "|") == name) {
      value = GetPartBy(value, 1, "|");
      break;
    }
    i++;
  }
  return value;
}
//-----------------------------------------------------------------------
// ClearStoredVariables
//-----------------------------------------------------------------------
function ClearStoredVariables() {
  VARIABLES = "";
  return;
}
//-----------------------------------------------------------------------------
// Sleep
//-----------------------------------------------------------------------------
function Sleep(milliseconds) {
  var start = new Date().getTime();
  while ((new Date().getTime() - start) < milliseconds) {
    // Do nothing
  }
  return;
}
//-----------------------------------------------------------------------------
// IsExplorer
//-----------------------------------------------------------------------------
function IsExplorer() {
  return (navigator.appName.indexOf("Explorer") != -1);
}
//-----------------------------------------------------------------------------
// IsSystem
//-----------------------------------------------------------------------------
function IsSystem(value) {
  return (navigator.platform.indexOf(value) != -1);
}
//-----------------------------------------------------------------------------
// IsInstalled
//-----------------------------------------------------------------------------
function IsInstalled() {
  return top.head.iid_IsInstalled();
}
//-----------------------------------------------------------------------------
// GetBrowserName
//-----------------------------------------------------------------------------
function GetBrowserName() {
  return navigator.appName + " " + navigator.userAgent;
}
//-----------------------------------------------------------------------------
// SetCharset
//-----------------------------------------------------------------------------
function SetCharset(value) {
  var meta = null;
  var i = 0;
  if (value != GetCharset()) {
    meta = top.document.getElementsByTagName("meta");
    for (i = 0; i < meta.length; i++) {
      if (meta[i].getAttribute("http-equiv") == "content-type") {
        meta[i].setAttribute("content", "text/html; charset=" + value);
      }
    }
  }
  return;
}
//-----------------------------------------------------------------------------
// GetCharset
//-----------------------------------------------------------------------------
function GetCharset() {
  var value = "";
  var meta = null;
  var i = 0;
  meta = top.document.getElementsByTagName("meta");
  for (i = 0; i < meta.length; i++) {
    if (meta[i].getAttribute("http-equiv") == "content-type") {
      value = meta[i].getAttribute("content");
      if ((i = value.indexOf("charset=")) != -1)
        value = value.substr(i + 8, value.length - i - 8);
    }
  }
  return value;
}
//-----------------------------------------------------------------------------
// UpdateCharset
//-----------------------------------------------------------------------------
function UpdateCharset() {
  if (IsSystem("Win"))
    SetCharset("iso-8859-1");
  else
    SetCharset("utf-8");
  return;
}
//-----------------------------------------------------------------------------
// SetProperty
//-----------------------------------------------------------------------------
function SetProperty(name, value) {
  // Firefox will always convert to utf-8 and Internet Explorer will always
  // encode to latin-1. Both independent of charset encoding. We always expect
  // latin-1 for Windows and utf-8 for other OS. This is handled by setting
  // correct charset during load. By URL encoding the data, we will always get
  // correct charset. To absolutly make sure we get correct charset, check if
  // value is utf-8 encoded for Linux/MacOSX.
  if (!IsSystem("Win"))
    if (UTF8.needEncoding(value))
      value = UTF8.encode(value);
  // Escape will handle the URL encoding, except '+' character (URL code for
  // white space).
  value = escape(value);
  while (value.indexOf("+") != -1)
    value = value.replace("+", "%2B");
  top.head.iid_SetProperty(name, value);
  return;
}
//-----------------------------------------------------------------------------
// GetProperty
//-----------------------------------------------------------------------------
function GetProperty(name) {
  var value = "";
  // See SetProperty note
  value = top.head.iid_GetProperty(name);
  value = unescape(value);
  return value;
}
//-----------------------------------------------------------------------------
// EnumProperty
//-----------------------------------------------------------------------------
function EnumProperty(name, index) {
  var value = "";
  // See SetProperty note
  value = top.head.iid_EnumProperty(name, index);
  value = unescape(value);
  return value;
}
//-----------------------------------------------------------------------------
// Invoke
//-----------------------------------------------------------------------------
function Invoke(name) {
  return top.head.iid_Invoke(name);
}
//-----------------------------------------------------------------------------
// GetProductName
//-----------------------------------------------------------------------------
function GetProductName() {
  var name = GetProperty("ConfigGlobal:Install:ProductName");
  if (name == "")
    name = "Net iD";
  return name;
}
//-----------------------------------------------------------------------------
// FormatVersion
//-----------------------------------------------------------------------------
function FormatVersion(verIn) {
  var verOut = "";
  if (verIn.length == 8) {
    for (i = 0; i < 4; i++) {
      if (!(verIn.charAt(2 * i) == '0'))
        verOut = verOut + verIn.substr(2 * i, 2);
      else
        verOut = verOut + verIn.substr(2 * i + 1, 1);
      if (i < 3)
        verOut = verOut + ".";
    }
  }
  return verOut;
}
//-----------------------------------------------------------------------------
// GetProductVersion
//-----------------------------------------------------------------------------
function GetProductVersion() {
  return FormatVersion(GetProperty('Version'));
}
//-----------------------------------------------------------------------------
// Refresh
//-----------------------------------------------------------------------------
function Refresh() {
  return Invoke("Refresh");
}
//-----------------------------------------------------------------------
// ClearConfigEntry
//-----------------------------------------------------------------------
function ClearConfigEntry(section, entry) {
  var value = "";
  var i = 0;
  value = "-delconfig -section " + section + " -entry \"" + entry + "\"";
  SetProperty("Command", value);
  Invoke("Run");
  // Verify entry cleared
  value = "ConfigLocal:" + section + ":" + entry;
  while (GetProperty(value) != "") {
    if (i++ >= 10)
      break;
    setTimeout('', 1000);
  }
  return;
}
//-----------------------------------------------------------------------------
// SetActiveIndex
//-----------------------------------------------------------------------------
function SetActiveIndex(index) {
  top.head.g_ActiveIndex = index;
  return;
}
//-----------------------------------------------------------------------------
// GetActiveIndex
//-----------------------------------------------------------------------------
function GetActiveIndex() {
  return top.head.g_ActiveIndex;
}
//-----------------------------------------------------------------------------
// SetActiveType
//-----------------------------------------------------------------------------
function SetActiveType(type) {
  top.head.g_ActiveType = type;
  return;
}
//-----------------------------------------------------------------------------
// GetActiveType
//-----------------------------------------------------------------------------
function GetActiveType() {
  return top.head.g_ActiveType;
}
//-----------------------------------------------------------------------------
// SetActiveInfo
//-----------------------------------------------------------------------------
function SetActiveInfo(info) {
  top.head.g_ActiveInfo = info;
  return;
}
//-----------------------------------------------------------------------------
// GetActiveInfo
//-----------------------------------------------------------------------------
function GetActiveInfo() {
  return top.head.g_ActiveInfo;
}
//-----------------------------------------------------------------------------
// GetPartBy
//-----------------------------------------------------------------------------
function GetPartBy(text, pos, c) {
  var text2 = "";
  text2 = text;
  while ((text2 != "") && (pos > 0)) {
    if (text2.indexOf(c) > 0)
      text2 = text2.substr(text2.indexOf(c) + 1, text2.length - text2.indexOf(c) - 1);
    else if (text2.indexOf(c) == 0)
      text2 = text2.substr(1, text2.length);
    else
      text2 = "";
    pos--;
  }
  if (text2 != "") {
    if (text2.indexOf(c) > 0)
      text2 = text2.substr(0, text2.indexOf(c));
    else if (text2.indexOf(c) == 0)
      text2 = "";
  }
  return text2;
}
//-----------------------------------------------------------------------------
// GetPart
//-----------------------------------------------------------------------------
function GetPart(text, pos) {
  return GetPartBy(text, pos, ';');
}
//-----------------------------------------------------------------------------
// GetPartCount
//-----------------------------------------------------------------------------
function GetPartCount(text) {
  var count = 0;
  while ((count < 32) && (GetPart(text, count) != ""))
    count += 1;
  return count;
}
//-----------------------------------------------------------------------------
// GetRdnPart
//-----------------------------------------------------------------------------
function GetRdnPart(text, pos) {
  var text2 = "";
  var i = 0;
  var j = 0;
  while (1) {
    i = text.indexOf('=');
    if (i == -1) {
      text2 = "";
      break;
    }
    else {
      text2 = text.substr(i + 1, text.length);
      if (text[i + 1] == '\"')
        j = text2.indexOf('\"');
      else
        j = text2.indexOf(',');
      if (j == -1)
        j = text2.length;
      text2 = text.substr(0, i + j + 1);
      if (text.indexOf('=') == -1)
        text = "";
      else
        text = text.substr(i + j + 2, text.length);
    }
    if (pos == 0)
      break;
    pos--;
  }
  while ((text2.length > 0) && (text2.charAt(0) == ' '))
    text2 = text2.substr(1, text2.length);
  return text2;
}
//-----------------------------------------------------------------------------
// GetRdnCount
//-----------------------------------------------------------------------------
function GetRdnCount(text) {
  var count = 0;
  while ((count < 16) && (GetRdnPart(text, count) != ""))
    count += 1;
  return count;
}
//-----------------------------------------------------------------------------
// GetRdnOid
//-----------------------------------------------------------------------------
function GetRdnOid(text) {
  return GetPartBy(text, 0, '=');
}
//-----------------------------------------------------------------------------
// GetRdnValue
//-----------------------------------------------------------------------------
function GetRdnValue(text, convert) {
  text = GetPartBy(text, 1, '=');
  if (convert)
    text = ConvertHtml(text);
  return text;
}
//-----------------------------------------------------------------------------
// GetValueByOid
//-----------------------------------------------------------------------------
function GetValueByOid(text, oid, convert) {
  var i = 0;
  var part = "";
  var value = "";
  while ((part = GetRdnPart(text, i)) != "") {
    if (GetRdnOid(part) == oid) {
      if (value != "")
        value += ", ";
      value += GetRdnValue(part, convert);
    }
    i++;
  }
  return value;
}
//-----------------------------------------------------------------------------
// InsertNewLine
//-----------------------------------------------------------------------------
function InsertNewLine(text) {
  var text2 = "";
  var i = 0;
  if (text.length >= 16) {
    if (text.indexOf(' ') >= 6) {
      i = text.indexOf(' ');
      text2 = text.substr(i + 1, text.length);
      text = text.substr(0, i) + "<br>" + text2;
    }
  }
  return text;
}
//-----------------------------------------------------------------------------
// StripPasswordPart
//-----------------------------------------------------------------------------
function StripPasswordPart(text) {
  if (text.indexOf('(') > 0)
    text = text.substr(0, text.indexOf('(') - 1);
  return text;
}
//-----------------------------------------------------------------------------
// GetPasswordPart
//-----------------------------------------------------------------------------
function GetPasswordPart(text) {
  var i = 0;
  i = text.indexOf('(');
  if (i > 0)
    text = text.substr(text.indexOf('(') + 1, text.length - i - 2);
  else
    text = "";
  return text;
}
//-----------------------------------------------------------------------------
// GetUploadFileData
//-----------------------------------------------------------------------------
function GetUploadFileData(file) {
  var value = "";
  var i = 0;
  if (file.files != null) {
    value = file.files.item(0).getAsDataURL();
    if ((i = value.indexOf(";base64,")) != -1) {
      i += 8;
      value = value.substr(i, value.length - i);
      // May be double base64 encode, so decode unless start with 'M'
      if (value.charAt(0) != 'M')
        value = BASE64.decode(value);
    }
  }
  return value;
}
//-----------------------------------------------------------------------------
// CopyToClipboard_NS
//-----------------------------------------------------------------------------
function CopyToClipboard_NS(text) {
  var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
  if (!str) 
    return false;
  str.data = text;
  var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
  if (!trans) 
    return false;
  trans.addDataFlavor("text/unicode");
  trans.setTransferData("text/unicode", str, text.length * 2);
  var clipid = Components.interfaces.nsIClipboard;
  var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(clipid);
  if (!clip) 
    return false;
  clip.setData(trans, null, clipid.kGlobalClipboard);
  return true;
}
//-----------------------------------------------------------------------------
// CopyToClipboard_IE
//-----------------------------------------------------------------------------
function CopyToClipboard_IE(text) {
  text.execCommand("RemoveFormat");
  text.execCommand("Copy");
  return true;
}
//-----------------------------------------------------------------------------
// CopyToClipboard
//-----------------------------------------------------------------------------
function CopyToClipboard(text) {
  if (window.clipboardData && clipboardData.setData) {
	  // Internet Explorer
		window.clipboardData.setData("Text", text);
	}
	else {
	  // Firefox
	  try {
      if (netscape.security.PrivilegeManager.enablePrivilege) {
        netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
        var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
        str.data = text;
        var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
        if (!trans)
          return;
        trans.addDataFlavor("text/unicode");
        trans.setTransferData("text/unicode", str, text.length * 2);
        var clipid = Components.interfaces.nsIClipboard;
        var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(clipid);
        if (!clip)
          return;
        clip.setData(trans, null, clipid.kGlobalClipboard);
      }
    } catch (ex) {
      return;
    }
	}
  return;
}
//-----------------------------------------------------------------------------
// HasClipboardSupport
//-----------------------------------------------------------------------------
function HasClipboardSupport() {
  var success = false;
  if ((navigator.appName.indexOf("Explorer") != -1) ||
      (navigator.appName.indexOf("Netscape") != -1))
    success = true;
  return success;
}
//-----------------------------------------------------------------------------
// SaveToFile
//-----------------------------------------------------------------------------
function SaveToFile(name, data) {
  var success = false;
  var w = null;
  var d = null;
  w = window.frames.w;
  if (w == null) {
    w = document.createElement('iframe');
    w.id = 'w';
    w.style.display = 'none';
    document.body.insertBefore(w);
    w = window.frames.w;
    if (w == null)
      w = window.open('', '_temp', 'width=100,height=100');
  }
  if (w != null) {
    d = w.document;
    d.open('application/octet-stream', 'replace');
    d.write(data);
    d.close();
    if (d.execCommand('SaveAs', 'true', name))
      success = true; 
    w.close();
  }
  return success;
}
//-----------------------------------------------------------------------------
// HasSaveFileSupport
//-----------------------------------------------------------------------------
function HasSaveFileSupport() {
  var success = false;
  /*
  if (navigator.appName.indexOf("Explorer") != -1)
    success = true;
  */  
  return success;
}
//-----------------------------------------------------------------------------
// Logout
//-----------------------------------------------------------------------------
function Logout(slot) {
  SetProperty('ActiveSlot', slot);
  return Invoke('Logout');
}
//-----------------------------------------------------------------------------
// EnumSlots
//-----------------------------------------------------------------------------
function EnumSlots(index) {
  return EnumProperty('Slot', index);
}
//-----------------------------------------------------------------------------
// EnumSoftSlots
//-----------------------------------------------------------------------------
function EnumSoftSlots(index) {
  return EnumProperty('SlotSoft', index);
}
//-----------------------------------------------------------------------------
// EnumReaderSlots
//-----------------------------------------------------------------------------
function EnumReaderSlots(index) {
  return EnumProperty('SlotCard', index);
}
//-----------------------------------------------------------------------------
// EnumCertificates
//-----------------------------------------------------------------------------
function EnumCertificates(index, other) {
  var value = "";
  if (index == 0) {
    Invoke('Reset');
    if (other)
      SetProperty('Other', "true");
    else
      SetProperty('Other', "false");
  }
  return EnumProperty('CertificateEx', index);
}
//-----------------------------------------------------------------------------
// EnumKeys
//-----------------------------------------------------------------------------
function EnumKeys(index) {
  return EnumProperty('Key', index);
}
//-----------------------------------------------------------------------------
// EnumProfile
//-----------------------------------------------------------------------------
function EnumProfile(index) {
  return EnumProperty('Profile', index);
}
//-----------------------------------------------------------------------
// IsUpdateAllowed
//-----------------------------------------------------------------------
function IsUpdateAllowed() {
  var allowed = false;
  var value = "";
  var n = 0;
  if (!IsSystem("Win")) {
    // Only Windows will have update problem (sandbox)
    allowed = true;
  }
  else {
    value = window.location.href;
    if (value.substr(0, 7) == "http://")
      n = 7;
    else if (value.substr(0, 8) == "https://")
      n = 8;
    if (n == 0) {
      // local file always allowed
      allowed = true;
    }
    else {
      if ((n = value.indexOf("/", n)) != -1)
        value = value.substr(0, n);
      if (GetProperty("ConfigGlobal:AllowedServers:" + value) == "1")
        allowed = true;
    }
  }
  return allowed;
}
//-----------------------------------------------------------------------------
// GetFileExtension
//-----------------------------------------------------------------------------
function GetFileExtension(file) {
  var n = 0;
  var extension = "";
  n = file.lastIndexOf('.');
  if (n > 0)
    extension = file.substr(n, file.length - n);
  return extension;
}
//-----------------------------------------------------------------------------
// ViewCertificate
//-----------------------------------------------------------------------------
function ViewCertificate(pos) {
  var cert = "";
  if ((cert = GetCertificateFromList(pos)) != "") {
    SetProperty('Certificate', cert);
    Invoke('ViewCertificate');
  }
  return;
}
//-----------------------------------------------------------------------------
// CreateCertificate
//-----------------------------------------------------------------------------
function CreateCertificate(slot, name, value) {
  Invoke('Reset')
  SetProperty('ActiveSlot', slot);
  if (name != "")
    SetProperty('FileName', name);
  if (value != "")
    SetProperty('Certificate', value);
  return Invoke('WriteCertificate');
}
//-----------------------------------------------------------------------------
// DeleteCertificate
//-----------------------------------------------------------------------------
function DeleteCertificate(slot, value) {
  Invoke('Reset')
  SetProperty('ActiveSlot', slot);
  SetProperty('Certificate', value);
  return Invoke('DeleteCertificate');
}
//-----------------------------------------------------------------------------
// DeleteToken
//-----------------------------------------------------------------------------
function DeleteToken(slot) {
  var rc = 0;
  Invoke('Reset')
  SetProperty('ActiveSlot', slot);
  rc = Invoke('DeleteToken');
  if (rc == 0)
    Refresh();
  return rc;
}
//-----------------------------------------------------------------------------
// CreateToken
//-----------------------------------------------------------------------------
function CreateToken(label, password, filename, value) {
  var rc = 0;
  Invoke('Reset');
  SetProperty('TokenLabel', label);
  if (filename != "")
    SetProperty('FileName', filename);
  if (value != "")
    SetProperty('TokenData', value);
  rc = Invoke('CreateToken');
  if (rc == 0) {
    if (password != "") {
      SetProperty('Password', password);
      rc = Invoke('Login');
      // Delete token on failure when content included
      if ((rc != 0) && (value != "")) {
        Invoke('DeleteToken');
      }
    }
    Refresh();
  }
  return rc;
}
//-----------------------------------------------------------------------------
// IsTokenPresent
//-----------------------------------------------------------------------------
function IsTokenPresent(slot) {
  var present = false;
  if (slot != "") {
    SetProperty('ActiveSlot', slot);
    if (GetProperty('TokenInfo') != "")
      present = true;
  }
  return present;
}
//-----------------------------------------------------------------------------
// IsReaderSlot
//-----------------------------------------------------------------------------
function IsReaderSlot(value) {
  if (value == "")
    return false;
  return (value < 100);
}
//-----------------------------------------------------------------------------
// GetPasswordList
//-----------------------------------------------------------------------------
function GetPasswordList(slot) {
  var list = "";
  var index = 0;
  var slot2 = 0;
  var name = "";
  var name2 = "";
  name = GetSlotDescription(slot);
  while ((value = EnumProperty("Slot", index)) != "") {
    slot2 = GetSlotId(value);
    name2 = GetSlotDescription(slot2);
    if (name == name2) {
      if ((name2 = GetPasswordDescription(slot2)) != "") {
        list += slot2 + "," + name2 + ";";
      }
    }
    index++;
  }
  return list;
}
//-----------------------------------------------------------------------------
// MayExportSoftToken
//-----------------------------------------------------------------------------
function MayExportSoftToken(slot) {
  var exportable = false;
  var index = 0;
  var value = 0;
  // Available from 5.4 (not MacOSX)
  if (!IsSystem("Mac")) {
    if (GetProperty('Version') >= "05040000") {
      if (slot == 0) {
        exportable = true;
      }
      else {
        while ((value = EnumProperty("SlotSoft", index)) != "") {
          if (GetSlotId(value) == slot) {
            if (GetFileExtension(GetSlotFileName(slot)).toLowerCase() == ".tkn")
              exportable = true;
            break;
          }
          index++;
        }
      }
    }
  }
  return exportable;
}
//-----------------------------------------------------------------------------
// GetSlotId
//-----------------------------------------------------------------------------
function GetSlotId(value) {
  return GetPart(value, 0);
}
//-----------------------------------------------------------------------------
// GetRealSlotId
//-----------------------------------------------------------------------------
function GetRealSlotId(value) {
  return GetPart(value, 1);
}
//-----------------------------------------------------------------------------
// GetSlotDescription
//-----------------------------------------------------------------------------
function GetSlotDescription(slot) {
  var value = "";
  var i = 0;
  if (IsReaderSlot(slot)) {
    value = GetSlotInfo(slot);
    value = GetPart(value, 1);
  }
  else {
    // Use file name as slot description
    value = GetSlotFileName(slot);
    if (((i = value.lastIndexOf('\\')) > 0) ||
        ((i = value.lastIndexOf('/')) > 0)) {
      value = value.substr(i + 1, value.length - i - 1);
    }
  }
  value = ConvertHtml(value);
  return value;
}
//-----------------------------------------------------------------------------
// GetSlotFileName
//-----------------------------------------------------------------------------
function GetSlotFileName(slot) {
  if (IsReaderSlot(slot)) {
    value = "";
  }
  else {
    value = GetTokenInfo(slot);
    value = GetPart(value, 5);
  }
  return value;
}
//-----------------------------------------------------------------------------
// GetTokenInfo
//-----------------------------------------------------------------------------
function GetTokenInfo(slot) {
  SetProperty('ActiveSlot', slot);
  return GetProperty('TokenInfo');
}
//-----------------------------------------------------------------------------
// GetSlotInfo
//-----------------------------------------------------------------------------
function GetSlotInfo(slot) {
  var index = 0;
  var value = "";
  while ((value = EnumSlots(index)) != "") {
    if (slot == GetSlotId(value))
      break;
    index++;
  }
  return value;
}
//-----------------------------------------------------------------------------
// GetCompleteTokenDescription
//-----------------------------------------------------------------------------
function GetCompleteTokenDescription(slot, convert) {
  var value = "";
  value = GetTokenInfo(slot);
  value = GetPart(value, 1);
  if (convert)
    value = ConvertHtml(value); 
  return value;
}
//-----------------------------------------------------------------------------
// GetTokenDescription
//-----------------------------------------------------------------------------
function GetTokenDescription(slot, convert) {
  var value = "";
  value = GetCompleteTokenDescription(slot, convert);
  value = StripPasswordPart(value);
  return value;
}
//-----------------------------------------------------------------------------
// GetTokenDescription
//-----------------------------------------------------------------------------
function GetTokenDescription(slot, convert) {
  var value = "";
  value = GetCompleteTokenDescription(slot, convert);
  value = StripPasswordPart(value);
  return value;
}
//-----------------------------------------------------------------------------
// GetTokenType
//-----------------------------------------------------------------------------
function GetTokenType(slot) {
  var value = "";
  if (IsReaderSlot(slot)) {
    value = GetTokenInfo(slot);
    value = GetPart(value, 4);
  } 
  else {
    value = "Soft";
  }
  return value;
}
//-----------------------------------------------------------------------------
// GetPasswordDescription
//-----------------------------------------------------------------------------
function GetPasswordDescription(slot) {
  var value = "";
  if (!IsReaderSlot(slot)) {
    value = "";
  }
  else {
    value = GetCompleteTokenDescription(slot, true);
    value = GetPasswordPart(value);
  }
  return value;
}
//-----------------------------------------------------------------------------
// GetTokenNumber
//-----------------------------------------------------------------------------
function GetTokenNumber(slot) {
  var value = "";
  value = GetTokenInfo(slot);
  return GetPart(value, 2);
}
//-----------------------------------------------------------------------------
// GetTokenManufacturer
//-----------------------------------------------------------------------------
function GetTokenManufacturer(slot) {
    var value = "";
    value = GetTokenInfo(slot);
    return GetPart(value, 3);
}
//-----------------------------------------------------------------------------
// GetTokenStatus
//-----------------------------------------------------------------------------
function GetTokenStatus(value) {
  status = GetPart(value, 8);
  if (status == "")
    return "";
  return " (" + status + ")";
}
//-----------------------------------------------------------------------------
// GetCertificateId
//-----------------------------------------------------------------------------
function GetCertificateId(value) {
  value = GetPart(value, 2);
  if (value == "")
    value = "<null>";
  return value;
}
//-----------------------------------------------------------------------------
// GetKeyUsage
//-----------------------------------------------------------------------------
function GetKeyUsage(value) {
  return GetPart(value, 5);
}
//-----------------------------------------------------------------------------
// GetKeySize
//-----------------------------------------------------------------------------
function GetKeySize(value) {
  return GetPart(value, 6);
}
//-----------------------------------------------------------------------------
// GetKeyEngine
//-----------------------------------------------------------------------------
function GetKeyEngine(value) {
  return GetPart(value, 7);
}
//-----------------------------------------------------------------------------
// ParseCertificate
//-----------------------------------------------------------------------------
function ParseCertificate(value) {
  SetProperty("Certificate", value);
  return GetProperty("CertificateInfo");
}
//-----------------------------------------------------------------------------
// GetCertificateName
//-----------------------------------------------------------------------------
function GetCertificateName(rdn, convert) {
  var name = "";
  if ((name = GetValueByOid(rdn, "2.5.4.3", convert)) == "") {
    name += GetValueByOid(rdn, "2.5.4.42", convert);
    if (name.length > 0) 
      name += " ";
    name += GetValueByOid(rdn, "2.5.4.4", convert);
  }
  return name;
}
//-----------------------------------------------------------------------------
// GetCertificateLabel
//-----------------------------------------------------------------------------
function GetCertificateLabel(value, all, convert) {
  var label = "";
  if (value != "") {
    label += GetCertificateName(GetCertificateSubject(value), convert);
    if (all) {
      label += ", ";
      label += GetCertificateName(GetCertificateIssuer(value), convert);
    }
  }
  return label;
}
//-----------------------------------------------------------------------------
// GetCertificateDescription
//-----------------------------------------------------------------------------
function GetCertificateDescription(value) {
  var description = "";
  var part = "";
  var i = 0;
  while ((part = GetRdnPart(value, i)) != "") {
    if (i > 0)
      description += ", ";
    description += GetRdnValue(part, true);
    i++;
  }
  return description;
}
//-----------------------------------------------------------------------------
// GetCertificateIssuer
//-----------------------------------------------------------------------------
function GetCertificateIssuer(value) {
  return GetPart(value, 4);
}
//-----------------------------------------------------------------------------
// GetCertificateSubject
//-----------------------------------------------------------------------------
function GetCertificateSubject(value) {
  return GetPart(value, 5);
}
//-----------------------------------------------------------------------------
// GetCertificateValidFrom
//-----------------------------------------------------------------------------
function GetCertificateValidFrom(value) {
  return GetPart(value, 6);
}
//-----------------------------------------------------------------------------
// GetCertificateValidTo
//-----------------------------------------------------------------------------
function GetCertificateValidTo(value) {
  return GetPart(value, 7);
}
//-----------------------------------------------------------------------
// IsCaCertificate
//-----------------------------------------------------------------------
function IsCaCertificate(value) {
  var ca = false;
  if (value != "") 
    if (GetPart(value, 8) == "1")
      ca = true;
  return ca;
}
//-----------------------------------------------------------------------------
// GetCertificateValue
//-----------------------------------------------------------------------------
function GetCertificateValue(value) {
  var i = 0;
  i = value.lastIndexOf(';');
  if (i == -1)
    value = "";
  else
    value = value.substr(i + 1, value.length);
  return value;
}
//-----------------------------------------------------------------------------
// GetMatchingKey
//-----------------------------------------------------------------------------
function GetMatchingKey(slot, id) {
  var key = "";
  var value = "";
  var index = 0;
  while ((key == "") && ((value = EnumKeys(index)) != "")) {
    if ((GetRealSlotId(value) == slot) && (GetCertificateId(value) == id))
      key = value;
    index++;
  }
  return key;
}
//-----------------------------------------------------------------------------
// HasComponent
//-----------------------------------------------------------------------------
function HasComponent(component) {
  var has = false;
  var i = 0;
  var text = "";
  while (!has && ((text = EnumProperty("Component", i)) != "") && (i < 16)) {
    text = GetPart(text, 0);
    text = text.substr(text.lastIndexOf('\\') + 1, text.length - text.lastIndexOf('\\') - 1);
    text = text.substr(0, text.indexOf('.'));
    if (component.length < text.length) {
      text = text.substr(text.length - component.length, component.length);
      if (text == component)
        has = true;
    }
    i++;
  }
  return has;
}
//-----------------------------------------------------------------------------
// MayChangeAdminPassword
//-----------------------------------------------------------------------------
function MayChangeAdminPassword(slot) {
  if (GetTokenType(slot).indexOf(".NET Smart Card") != -1)
    return true;
  return false;
}
//-----------------------------------------------------------------------------
// ShouldMapWriteFirstSlot
//-----------------------------------------------------------------------------
function ShouldMapWriteFirstSlot(slot) {
  if (GetTokenType(slot).indexOf("GemXpresso 3") != -1)
    return false;
  return true;
}
//-----------------------------------------------------------------------------
// Login
//-----------------------------------------------------------------------------
function Login(slot, type, pwd) {
  Invoke("Reset");
  SetProperty("ActiveSlot", slot);
  SetProperty("PasswordType", type);
  SetProperty("Password", pwd);
  return Invoke("Login");
}
//-----------------------------------------------------------------------------
// Logout
//-----------------------------------------------------------------------------
function Logout(slot) {
  Invoke("Reset");
  SetProperty("ActiveSlot", slot);
  return Invoke("Logout");
}
//-----------------------------------------------------------------------------
// ChangePassword
//-----------------------------------------------------------------------------
function ChangePassword(slot, oldpwd, newpwd) {
  Invoke("Reset");
  SetProperty("ActiveSlot", slot);
  SetProperty("Password", oldpwd);
  SetProperty("NewPassword", newpwd);
  return Invoke("ChangePassword");
}
//-----------------------------------------------------------------------------
// UnlockPassword
//-----------------------------------------------------------------------------
function UnlockPassword(slot, puk, newpwd) {
  Invoke("Reset");
  SetProperty("ActiveSlot", slot);
  SetProperty("UnlockPassword", puk);
  SetProperty("NewPassword", newpwd);
  return Invoke("UnlockPassword");
}
//-----------------------------------------------------------------------------
// InitToken
//-----------------------------------------------------------------------------
function InitToken(profile, pwd, puk, label) {
  Invoke("Reset");
  SetProperty("Profile", profile);
  SetProperty("Password", pwd);
  SetProperty("UnlockPassword", puk);
  SetProperty("TokenLabel", label);
  return Invoke("InitToken");
}
//-----------------------------------------------------------------------------
// DeleteAllFiles
//-----------------------------------------------------------------------------
function DeleteAllFiles(slot, pwd, pwd2) {
  var rc = 0;
  var slot2 = 0;
  if (pwd2 != "") {
    slot2 = slot;
    slot2++;
  }
  Invoke("Reset");
  SetProperty("ActiveSlot", slot);
  SetProperty("Password", pwd);
  if ((rc = Invoke("Login")) == 0) {
    DeleteAllCertificates(slot);
    DeleteAllKeys(slot);
    if (slot2 != 0) {
      SetProperty("ActiveSlot", slot2);
      SetProperty("Password", pwd2);
      if ((rc = Invoke("Login")) == 0) {
        DeleteAllCertificates(slot2);
        DeleteAllKeys(slot2);
      }
    }
  }
  return rc;
}
//-----------------------------------------------------------------------------
// ResetToken
//-----------------------------------------------------------------------------
function ResetToken(slot, pwd, pwd2, files, files2) {
  var rc = 0;
  var index = 0;
  var file = "";
  var i = 0;
  // Start with standard delete of all files, will verify password
  if ((rc = DeleteAllFiles(slot, pwd, pwd2)) == 0) {
    Invoke("Reset");
    // Set active slot and password
    SetProperty("ActiveSlot", slot);
    SetProperty("Password", pwd);
    // Set eventual file list
    index = 0;
    while ((file = GetPartBy(files, index, ",")) != "") {
      SetProperty("ConfigLocal:Reset:" + GetPartBy(file, 0, "="), GetPartBy(file, 1, "="));
      index++;
    }
    // Call Reset Token
    rc = Invoke("ResetToken");
    // Reset eventual file list
    index = 0;
    while ((file = GetPartBy(files, index, ",")) != "") {
      SetProperty("ConfigLocal:Reset:" + GetPartBy(file, 0, "="), "");
      index++;
    }
    // Eventual next slot
    if ((rc == 0) && (pwd2 != "") && (files2 != "")) {
      slot++;
      pwd = pwd2;
      files = files2;
      // Set active slot and password
      SetProperty("ActiveSlot", slot);
      SetProperty("Password", pwd);
      // Set eventual file list
      index = 0;
      while ((file = GetPartBy(files, index, ",")) != "") {
        SetProperty("ConfigLocal:Reset:" + GetPartBy(file, 0, "="), GetPartBy(file, 1, "="));
        index++;
      }
      // Call Reset Token
      rc = Invoke("ResetToken");
      // Reset eventual file list
      index = 0;
      while ((file = GetPartBy(files, index, ",")) != "") {
        SetProperty("ConfigLocal:Reset:" + GetPartBy(file, 0, "="), "");
        index++;
      }
    }
  }
  return rc;
}
//-----------------------------------------------------------------------------
// EnumCrypt
//-----------------------------------------------------------------------------
function EnumCrypt(index) {
  return EnumProperty('Crypt', index);
}
//-----------------------------------------------------------------------------
// GetCryptDrive
//-----------------------------------------------------------------------------
function GetCryptDrive(value) {
  return GetPart(value, 0).toUpperCase();
}
//-----------------------------------------------------------------------------
// GetCryptName
//-----------------------------------------------------------------------------
function GetCryptName(value) {
  return GetPart(value, 1);
}
//-----------------------------------------------------------------------------
// GetCryptPath
//-----------------------------------------------------------------------------
function GetCryptPath(value) {
  return GetPart(value, 2);
}
//-----------------------------------------------------------------------------
// GetCryptValue
//-----------------------------------------------------------------------------
function GetCryptValue(drive, select) {
  var index = 0;
  var value = "";
  while ((value = EnumCrypt(index)) != "") {
    if (drive == GetCryptDrive(value)) {
      if (select) {
        SetProperty("Drive", GetCryptDrive(value));
        SetProperty("Name", GetCryptName(value));
        SetProperty("Path", GetCryptPath(value));
      }
      break;
    }
    index++;
  }
  return value;
}
//-----------------------------------------------------------------------------
// CryptIsMounted
//-----------------------------------------------------------------------------
function CryptIsMounted(drive) {
  var value = "";
  value = GetCryptValue(drive, false);
  value = GetPart(value, 0);
  return (value.toUpperCase() == value);
}
//-----------------------------------------------------------------------------
// CryptMountAll
//-----------------------------------------------------------------------------
function CryptMountAll() {
  return Invoke("CryptMountAll");
}
//-----------------------------------------------------------------------------
// CryptUnmountAll
//-----------------------------------------------------------------------------
function CryptUnmountAll() {
  return Invoke("CryptUnmountAll");
}
//-----------------------------------------------------------------------------
// CryptMount
//-----------------------------------------------------------------------------
function CryptMount(drive) {
  var rc = -1;
  var value = "";
  if ((value = GetCryptValue(drive, true)) != "")
    rc = Invoke("CryptMount");
  return rc;
}
//-----------------------------------------------------------------------------
// CryptUnmount
//-----------------------------------------------------------------------------
function CryptUnmount(drive) {
  var rc = -1;
  var value = "";
  if ((value = GetCryptValue(drive, true)) != "")
    rc = Invoke("CryptUnmount");
  return rc;
}
//-----------------------------------------------------------------------------
// CryptDelete
//-----------------------------------------------------------------------------
function CryptDelete(drive) {
  var rc = 0;
  var value = "";
  if ((value = GetCryptValue(drive, true)) != "") {
    Invoke("CryptUnmount");
    rc = Invoke("CryptConfigDelete");
  }
  Refresh();
  return rc;
}
//-----------------------------------------------------------------------------
// CryptAdd
//-----------------------------------------------------------------------------
function CryptAdd(drive, name, path, size, keyid, pwd, cert) {
  var rc = 0;
  SetProperty("Drive", drive);
  SetProperty("Name", name);
  SetProperty("Path", path);
  SetProperty("Size", size);
  SetProperty("KeyId", keyid);
  SetProperty("Password", pwd);
  SetProperty("Certificate", cert);
  rc = Invoke("CryptFormat");
  if (rc == 0)
    rc = Invoke("CryptConfigAdd");
  Refresh();
  return rc;
}
//-----------------------------------------------------------------------------
// Sign
//-----------------------------------------------------------------------------
function Sign(cert, data, authenticate) {
  var rc = 0;
  SetProperty('Certificate', cert);
  SetProperty('DataToBeSigned', data);
  if (authenticate)
    SetProperty('Authentication', 'true');
  else
    SetProperty('Authentication', 'false');
  SetProperty('Base64', 'true');
  SetProperty('URLEncode', 'false');
  rc = Invoke('Sign');
  if (rc == 0)
    rc = GetProperty('Signature');
  return rc;
}
//-----------------------------------------------------------------------------
// DeleteAllCertificates
//-----------------------------------------------------------------------------
function DeleteAllCertificates(slotid) {
    var rc = 0;
    var index = 0;
    var value = "";
    var count = 0;
    // Try delete all certificates, ignore failure, continue with next. Will
    // keep all read-only certificates
    while ((value = EnumCertificates(index, false)) != "") {
        if (slotid == GetRealSlotId(value)) {
            SetProperty("ActiveSlot", GetRealSlotId(value));
            SetProperty("Certificate", GetCertificateValue(value));
            if (Invoke("DeleteCertificate") == 0) {
                // No increase of index counter, use count variables to detect
                // failures (avoid infinite loop). 
                if (count++ < 10)
                {
                    continue;
                }
            }
        }
        count = 0;
        index++; 
    } 
    return;
}
//-----------------------------------------------------------------------------
// DeleteAllKeys
//-----------------------------------------------------------------------------
function DeleteAllKeys(slotid) {
    var rc = 0;
    var index = 0;
    var value = "";
    var count = 0;
    // Try delete all keys, ignore failure, continue with next. Will keep all 
    // read-only keys
    while ((value = EnumKeys(index)) != "") {
        if (slotid == GetRealSlotId(value)) {
            SetProperty("ActiveSlot", GetRealSlotId(value));
            SetProperty("KeyId", "0x" + GetPart(value, 2));
            if (Invoke("DeleteKey") == 0) {
                // No increase of index counter, use count variables to detect
                // failures (avoid infinite loop). 
                if (count++ < 10)
                {
                    continue;
                }
            }
        }
        count = 0;
        index++; 
    } 
    return;
}
